'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _npm = require('npm');

var _npm2 = _interopRequireDefault(_npm);

var isScaffold = function isScaffold(_ref2) {
  var _ref2$keywords = _ref2.keywords;
  var keywords = _ref2$keywords === undefined ? [] : _ref2$keywords;
  var _ref2$name = _ref2.name;
  var name = _ref2$name === undefined ? '' : _ref2$name;
  return name.substr(0, 3) === 'cf-' || keywords.indexOf('cloverfield-scaffold') !== -1 || keywords.indexOf('cloverfield') !== -1 && keywords.indexOf('scaffold') !== -1;
};

var modulesReady = function modulesReady(resolve, reject) {
  return function (error, tree) {
    if (error) {
      return reject(error);
    }

    var deps = tree.dependencies;
    var scaffolds = Object.keys(deps).reduce(function (result, key) {
      return(
        // Search only for Cloverfield Scaffolds
        _extends(result, isScaffold(deps[key]) ? _defineProperty({}, deps[key].name.replace(/^cf-/, ''), deps[key].realPath) : {})
      );
    }, {});

    resolve(scaffolds);
  };
};

var loaded = function loaded(resolve, reject) {
  return function (error) {
    if (error) {
      return reject(error);
    }

    // List all npm dependencies
    return _npm2['default'].commands.ls([], true, modulesReady(resolve, reject));
  };
};

// TODO: add caching
var findScaffolds = function findScaffolds() {
  return(
    // Configure npm to search for dependencies globally with minimal depth
    new Promise(function () {
      return _npm2['default'].load({ global: true, silent: true, depth: 0 }, loaded.apply(undefined, arguments));
    })
  );
};

exports['default'] = findScaffolds;
module.exports = exports['default'];